
PRAGMA foreign_keys = OFF;
DROP TABLE IF EXISTS "main"."Answers";
CREATE TABLE [Answers] (  [_id] INTEGER NOT NULL UNIQUE, [question_id] INTEGER NOT NULL,   [answer_no] INTEGER NOT NULL,   [content] TEXT NOT NULL,   [score] integer NOT NULL);

DROP TABLE IF EXISTS "main"."Characters";
CREATE TABLE [Characters] (  [_id] integer NOT NULL UNIQUE,  [image_id] INTEGER NOT NULL, [name] TEXT NOT NULL,   [profession] TEXT NOT NULL,   [height_and_weight] TEXT,   [bwh] TEXT,   [age] INTEGER DEFAULT 20,   [type] TEXT,   [detail] TEXT,   [is_completed] BOOLEAN NOT NULL DEFAULT false,    [current_progress] INT DEFAULT 0,   [last_chat_time] INTEGER DEFAULT 0, [gender] TEXT DEFAULT 'female',  [score] INT DEFAULT 0, has_unread_msg INTEGER DEFAULT 1,is_show INTEGER DEFAULT 1);

DROP TABLE IF EXISTS "main"."MsgWillBeSent";
CREATE TABLE [MsgWillBeSent] (  [_id] INTEGER PRIMARY KEY AUTOINCREMENT,   [character_id] INT NOT NULL,   [question_id] int NOT NULL,   [send_time] INT NOT NULL);


DROP TABLE IF EXISTS "main"."Questions";
CREATE TABLE [Questions] (  [_id] INTEGER NOT NULL UNIQUE,   [user_id] INTEGER NOT NULL,   [content] text NOT NULL,   [question_no] INTEGER NOT NULL,   [isNextEnding] BOOLEAN);


DROP TABLE IF EXISTS "main"."Record";
CREATE TABLE [Record] (
[_id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
[character_id] INT NOT NULL,
[content] TEXT NOT NULL, 
[chat_time] INT NOT NULL,
[msg_type] BOOLEAN NOT NULL,
[msg_id] INTEGER DEFAULT 0,
CONSTRAINT "IdContent" UNIQUE ("msg_id", "content") ON CONFLICT REPLACE
);

DROP VIEW IF EXISTS "main"."ChatList";
CREATE VIEW [ChatList] AS select * from Characters where Characters.[current_progress] != 0;

DROP VIEW IF EXISTS "main"."LastChatRecord";
CREATE VIEW [LastChatRecord] AS select Characters.[_id],Characters.[name],Characters.[is_show], Characters.[image_id],Characters.[has_unread_msg], Record.[content], max(Record.[chat_time]) as last_chat_time from Record,Characters where Characters.[_id] = Record.[character_id] group by Record.[character_id] order by last_chat_time desc;
